## why3 1.2.0

=== examples/gcd/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
GEN=euclideanAlgorithm63
OBJ=$(GEN)

GENML = $(addsuffix .ml, $(GEN))
ML = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(GENML)

doc:
	$(WHY3) doc ../gcd.mlw
	$(WHY3) session html .

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(GENML): ../gcd.mlw
	$(WHY3) extract -D ocaml64 -L .. -o $@ gcd.EuclideanAlgorithm63

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

clean::
	rm -f $(GENML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f gcd__*.ml*

# javascript


JSMAIN=jsmain

JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml.syntax \
          -syntax camlp4o

$(JSMAIN).js: $(JSMAIN).byte
	js_of_ocaml -pretty -noinline $(JSMAIN).byte


$(JSMAIN).byte: $(ML) jsmain.ml
	$(JSOCAMLC) $(INCLUDE) -o $@ -linkpkg $^


%.cmo: %.ml
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmi: %.mli
	$(JSOCAMLC) $(INCLUDE) -annot -c $<


clean::
	rm -f *.cm[io] $(NAME).byte $(NAME).js

=== debian/changelog ===
why3 (1.2.0-3ubuntu1) eoan; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Skip why3+z3 test on ppc64el, as it hangs indefinitely.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 16 Oct 2019 10:30:48 +0200

why3 (1.2.0-3) unstable; urgency=medium

  * why3 1.2.0 supports z3 up to version 4.8.4 only (closes: #942344)
    - add a version constraint to Recommends
    - add a version constraint to the dependencies of test why3+z3
    - flag test why3+z3 as skip-not-installable
  * Standards-Version 4.4.1 (no change)

 -- Ralf Treinen <treinen@debian.org>  Tue, 15 Oct 2019 20:42:34 +0200

why3 (1.2.0-2ubuntu1) eoan; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Skip why3+z3 test on ppc64el, as it hangs indefinitely.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 30 Aug 2019 08:27:50 +0200

why3 (1.2.0-2) unstable; urgency=medium

  * debian/rules: add build target 
  * Standards-Version 4.4.0 (no change)
  * Patch lablgtk3-beta6: Port to version beta6 of lablgtk3. Patch picked
    from upstream git. This fixes an issue with why3 not detecting
    lablgtk3-sourceview and hence not building the graphical interface.

 -- Ralf Treinen <treinen@debian.org>  Thu, 29 Aug 2019 21:23:49 +0200

why3 (1.2.0-1ubuntu4) eoan; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 21 Aug 2019 19:50:11 +0200

why3 (1.2.0-1ubuntu3) eoan; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 05 Aug 2019 15:04:27 +0200

why3 (1.2.0-1ubuntu2) eoan; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 27 Jul 2019 10:17:03 +0200

why3 (1.2.0-1ubuntu1) eoan; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Skip why3+z3 test on ppc64el, as it hangs indefinitely.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 25 Jul 2019 10:05:41 +0200

why3 (1.2.0-1) unstable; urgency=medium

  * New upstream version
  * Also build the library in bytecode
  * libwhy3-ocaml-dev: add Suggests:ocaml-findlib
  * Re-activate building of the ide, now using lablgtk3

 -- Ralf Treinen <treinen@debian.org>  Fri, 15 Feb 2019 08:19:55 +0100

why3 (1.1.1-4) unstable; urgency=medium

  * Add build-dependency ocaml-findlib (closes: #921465)
  * Replace dependency on debhelper by debhelper-compat
  * Enable coq support

 -- Ralf Treinen <treinen@debian.org>  Wed, 06 Feb 2019 20:57:54 +0100

why3 (0.88.3-3ubuntu1) cosmic; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Skip why3+z3 test on ppc64el/s390x, as it hangs indefinitely.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 04 Jun 2018 16:01:06 +0200

why3 (0.88.3-2ubuntu1) cosmic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Skip why3+z3 test on ppc64el/s390x, as it hangs indefinitely.
    - Implement per-architecture handling of the why3+cvc4 autopkgtest,
      since cvc4 is only available on x86.
  * Dropped changes, included in Debian:
    - debian/patches/portable-getopt.patch: fix unportable assumptions in
      getopt_long() handling.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 15 May 2018 16:17:06 -0700

=== debian/control ===
Source: why3
Section: math
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Ralf Treinen <treinen@debian.org>
Build-Depends:
  debhelper-compat (= 12), dh-ocaml,
  ocaml-nox (>= 3.11.2),
  ocaml-findlib,
  menhir, libmenhir-ocaml-dev,
  libzarith-ocaml-dev,
  libsqlite3-ocaml-dev,
  libzip-ocaml-dev,
  libocamlgraph-ocaml-dev,
  coq, libcoq-ocaml-dev,
  liblablgtk3-ocaml-dev, liblablgtksourceview3-ocaml-dev,
  tex-common
Build-Depends-Indep:
  rubber, hevea, lmodern,
  texlive-plain-generic,
  texlive-latex-recommended, texlive-latex-extra,
  texlive-fonts-recommended,
  texlive-bibtex-extra
Standards-Version: 4.4.1
Homepage: http://why3.lri.fr/
Vcs-Git: https://salsa.debian.org/ocaml-team/why3.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/why3

Package: why3
Architecture: any
Depends:
  ${shlibs:Depends},
  ${ocaml:Depends},
  ${misc:Depends},
Recommends: cvc3 | cvc4 | why3-coq | spass | z3 (<< 4.8.5) | alt-ergo (>= 2.0.0)
Suggests: why3-examples
Description: Software verification platform
 Why3 is a platform for deductive program verification. It provides a
 rich language for specification and programming, called WhyML, and
 relies on external theorem provers, both automated and interactive,
 to discharge verification conditions. Why3 comes with a standard
 library of logical theories (integer and real arithmetic, Boolean
 operations, sets and maps, etc.) and basic programming data
 structures (arrays, queues, hash tables, etc.). A user can write
 WhyML programs directly and get correct-by-construction OCaml
 programs through an automated extraction mechanism. WhyML is also
 used as an intermediate language for the verification of C, Java, or
 Ada programs.
 .
 Why3 is a complete reimplementation of the former Why platform. Among
 the new features are: numerous extensions to the input language, a
 new architecture for calling external provers, and a well-designed
 API, allowing to use Why3 as a software library. An important
 emphasis is put on modularity and genericity, giving the end user a
 possibility to easily reuse Why3 formalizations or to add support for
 a new external prover if wanted.

Package: why3-coq
Architecture: any
Depends: coq-${F:CoqABI}, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Recommends: why3
Description: Coq support for the why3 verification platform
 This package contains the compiled coq files that are necessary to
 use the coq proof assistant together with the why3 deductive
 verification platform.

Package: libwhy3-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Suggests: ocaml-findlib
Provides: ${ocaml:Provides}
Section: ocaml
Description: OCaml librariries for why3 (dev)
 This package contains the libraries of the why3 verification platform
 for developing applications using why3.

Package: why3-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: why3
Description: Examples for the why3 verification platform
 This package contains examples, both of program verification tasks
 and pure logical verification tasks, for the why3 software verification
 platform.

Package: why3-doc-html
Architecture: all
Depends: ${misc:Depends}
Suggests: why3
Description: HTML Documentation of the why3 verification platform
 This package contains the tutorial and reference manual of the
 why3 verification platform in HTML format.

Package: why3-doc-pdf
Architecture: all
Depends: ${misc:Depends}
Suggests: why3
Description: PDF Documentation of the why3 verification platform
 This package contains the tutorial and reference manual of the
 why3 verification platform in PDF format.

=== debian/tests/control ===
Tests: why3+alt-ergo
Depends: why3, alt-ergo (>= 2.0.0)
Restrictions: skip-not-installable

Tests: why3+cvc3
Depends: why3, cvc3
Restrictions: skip-not-installable

Tests: why3+cvc4
Depends: why3, cvc4
Restrictions: skip-not-installable

Tests: why3+spass
Depends:why3, spass
Restrictions: skip-not-installable

Tests: why3+z3
Depends:why3, z3 (<< 4.8.5)
Restrictions: skip-not-installable

Tests: why3+coq
Depends: why3, why3-coq, coq

=== debian/watch ===
version=3
opts=uversionmangle=s/-/~/ \
https://gforge.inria.fr/frs/?group_id=2990 .*/why3-(.*)\.tar\.gz

## why3 1.2.1

=== examples/defunctionalization/Makefile ===


BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif


MAIN = main
OBJ = defunctionalization
ML  = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT = ocamlopt -noassert -inline 1000

all: $(MAIN).opt

extract: $(ML)

doc:
	$(WHY3) doc ../defunctionalization.mlw
	$(WHY3) session html ../defunctionalization.mlw
	@echo firefox ../defunctionalization.html why3session.html

$(MAIN).byte: $(CMO) $(MAIN).cmo
	ocamlc -g $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ $^

$(MAIN).opt: $(CMX) $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(ML): ../defunctionalization.mlw
	$(WHY3) extract -D ocaml64 --recursive -L .. -o $@ \
		defunctionalization.DirectSem \
		defunctionalization.CPS \
		defunctionalization.Defunctionalization

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

%.cmo: %.ml
	ocamlc $(INCLUDE) -annot -g -c $<

%.cmi: %.mli
	ocamlc $(INCLUDE) -annot -g -c $<

clean::
	rm -f $(ML) *.cm[xio] $(MAIN).opt

=== examples/euler001/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
OBJ=euler001

ML  = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(ML)

doc:
	$(WHY3) doc ../euler001.mlw
	$(WHY3) session html .

$(MAIN).byte: $(CMO)  $(MAIN).cmo
	ocamlc $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ $^

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(ML): ../euler001.mlw
	$(WHY3) extract -D ocaml64 $< -o $@

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

%.cmo: %.ml
	ocamlc $(INCLUDE) -annot -c $<

%.cmi: %.mli
	ocamlc $(INCLUDE) -annot -c $<

clean::
	rm -f $(ML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f why3__*.ml* euler001__*.ml* int__*.ml*

=== examples/multiprecision/Makefile ===
BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
endif

all: why3 extract

clean:
	rm -rf build

why3:
	make -C ../..

dir:
	mkdir -p build

MLWFILES= $(addsuffix .mlw, toom logical div mul sub add compare util)

cfiles: why3 dir
	$(WHY3) extract -D c -L . --recursive --modular --interface -o build/ \
	wmpn.mlw
	#$(MLWFILES)

extract: why3 dir cfiles

CFILES = build/uint64gmp.c build/toom.c build/div.c build/logical.c build/mul.c build/sub.c build/add.c build/compare.c build/util.c build/int32.c

tests: extract check-gmp
	gcc -O2 -Wall -Wno-unused-function -g -std=c11 -pedantic tests.c $(CFILES) -I$(GMP_DIR) -Irandom -L$(GMP_LIB) -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -lgmp -o build/tests
	gcc -O2 -Wall -Wno-unused-function -g -std=c11 -pedantic -DCOMPARE_MINI tests.c $(CFILES) -I$(GMP_DIR) -Irandom -Imini-gmp -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -o build/minitests
	./build/tests
	./build/minitests

bench-tests: extract
	gcc -O2 -Wall -Wno-unused-function -g -std=c11 tests.c $(CFILES) -Ibench-include -Irandom -fomit-frame-pointer -fno-tree-vectorize -lgmp -o build/bench-tests


build/why3%bench: extract check-gmp
	gcc -O2 -Wall -Wno-unused-function -g -std=c11 -DTEST_WHY3 -DTEST_`echo $* | tr [:lower:] [:upper:]` tests.c $(CFILES) -I$(GMP_DIR) -Irandom -L$(GMP_LIB) -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -lgmp -o $@

build/gmp%bench: extract check-gmp
	gcc -O2 -Wall -Wno-unused-function -g -std=c11 -DTEST_GMP -DTEST_`echo $* | tr [:lower:] [:upper:]` tests.c $(CFILES) -I$(GMP_DIR) -Irandom -L$(GMP_LIB) -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -lgmp -o $@

build/minigmp%bench: extract
	gcc -O2 -Wall -Wno-unused-function -g -std=c11 -DTEST_MINIGMP -DTEST_`echo $* | tr [:lower:] [:upper:]` tests.c $(CFILES) -I$(GMP_DIR) -Imini-gmp -Irandom -fomit-frame-pointer -mtune=haswell -march=haswell -fno-tree-vectorize -o $@

alltests: tests build/why3addbench build/why3mulbench build/why3toombench build/why3divbench build/gmpaddbench build/gmpmulbench build/gmptoombench build/gmpdivbench build/minigmpaddbench build/minigmpmulbench build/minigmpdivbench build/minigmptoombench

data: alltests
	mkdir -p bench
	./build/why3addbench > bench/why3add
	./build/why3mulbench > bench/why3mul
	./build/why3toombench > bench/why3toom
	./build/why3divbench > bench/why3div
	./build/gmpaddbench > bench/gmpadd
	./build/gmpmulbench > bench/gmpmul
	./build/gmptoombench > bench/gmptoom
	./build/gmpdivbench > bench/gmpdiv
	./build/minigmpaddbench > bench/minigmpadd
	./build/minigmpmulbench > bench/minigmpmul
	./build/minigmptoombench > bench/minigmptoom # minigmp uses schoolbook mul in that case too
	./build/minigmpdivbench > bench/minigmpdiv

plots: data
	make all -C plots

check-gmp:
ifndef GMP_DIR
	$(error GMP_DIR is undefined)
endif
ifndef GMP_LIB
	$(error GMP_LIB is undefined)
endif

=== examples/sudoku/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
GEN =sudoku
OBJ=$(GEN)

GENML = $(addsuffix .ml, $(GEN))
ML = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT = ocamlopt -noassert -inline 1000

all: $(MAIN).opt

extract: $(GENML)

doc:
	$(WHY3) doc ../sudoku.mlw
	$(WHY3) session html .

$(MAIN).byte: $(CMO) $(MAIN).cmo
	ocamlc -g $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ $^

$(MAIN).opt: $(CMX) $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(GENML): ../sudoku.mlw
	$(WHY3) extract -D ocaml64 --recursive -o $@ -L .. sudoku.Test

# javascript


JSMAIN=jsmain

JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml.syntax \
          -syntax camlp4o

$(JSMAIN).js: $(JSMAIN).byte
	js_of_ocaml +nat.js $(JSMAIN).byte

$(JSMAIN).byte: $(CMO) $(JSMAIN).cmo
	$(JSOCAMLC) $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ -linkpkg $^

%.cmo: %.ml
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmi: %.mli
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

clean::
	rm -f $(GENML) *.annot *.o *.cm[xio] $(MAIN).opt $(MAIN).byte
	rm -f sudoku__*.ml why3__*.ml
	rm -f int__Int.ml map__Map.ml array__Array.ml

=== examples/vstte10_max_sum/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
OBJ=vstte10_max_sum

ML  = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(ML)

doc:
	$(WHY3) doc ../vstte10_max_sum.mlw
	$(WHY3) session html .

$(MAIN).byte: $(CMO)  $(MAIN).cmo
	ocamlc $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ $^

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(ML): ../vstte10_max_sum.mlw
	$(WHY3) extract -D ocaml64 -o $@ $^

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

%.cmo: %.ml
	ocamlc $(INCLUDE) -annot -c $<

%.cmi: %.mli
	ocamlc $(INCLUDE) -annot -c $<

clean::
	rm -f $(ML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f why3__*.ml* vstte10_max_sum__*.ml* int__*.ml*

=== examples/vstte12_combinators/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
GEN=vstte12_combinators
OBJ=$(GEN) parse

GENML = $(addsuffix .ml, $(GEN))
ML = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(GENML)

doc:
	$(WHY3) doc ../vstte12_combinators.mlw
	$(WHY3) session html .

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(GENML): ../vstte12_combinators.mlw
	$(WHY3) extract -D ocaml64 -o $@ $<

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

clean::
	rm -f $(GENML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f vstte12_combinators__*.ml*

# javascript


JSMAIN=jsmain

JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml.syntax \
          -syntax camlp4o

$(JSMAIN).js: $(JSMAIN).byte
	js_of_ocaml -pretty -noinline +nat.js $(JSMAIN).byte


$(JSMAIN).byte: $(CMO) jsmain.ml
#	$(JSOCAMLC) $(INCLUDE) -o $@ -linkpkg $^
	$(JSOCAMLC) $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ -linkpkg $^


%.cmo: %.ml
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmi: %.mli
	$(JSOCAMLC) $(INCLUDE) -annot -c $<


clean::
	rm -f *.cm[io] $(NAME).byte $(NAME).js

=== examples/multiprecision/plots/Makefile ===
all:
	./divplot &
	./divrelative &
	./mulrelative &
	./addrelative &
	./addplot &
	./minidivrelative &
	./minimulrelative &
	./miniaddrelative &
#	./gmpdivplot &
#	./gmpmulplot &
#	./gmpaddplot &
	./toomrelative
	./minitoomrelative

=== examples/use_api/runstrat/Makefile ===

BINDIR=/usr/local/bin

OCAMLFIND = ocamlfind

OCAMLFIND_OPT = $(addprefix -package ,$(PACKAGES)) -annot
OCAMLOPT = $(OCAMLFIND) ocamlopt $(OCAMLFIND_OPT)
OCAMLC = $(OCAMLFIND) ocamlc $(OCAMLFIND_OPT)
OCAMLDEP = $(OCAMLFIND) ocamldep $(OCAMLFIND_OPT)

PACKAGES = unix str

all:makejob runstrat
opt: makejob.opt runstrat.opt
byte: makejob.byte runstrat.byte

printconf:
	echo $(OCAMLPATH)
	ocamlfind printconf

makeproto.cmo: makeproto.cmi
makeproto.cmx: makeproto.cmi

makejob.opt: makeproto.cmx makejob.ml
makejob.byte: makeproto.cmo makejob.ml

makejob: makejob.opt
	@rm -f makejob
	ln -s makejob.opt makejob

runstrat.opt runstrat.byte: PACKAGES += why3
runstrat.opt: makeproto.cmx runstrat.ml
runstrat.byte: makeproto.cmo runstrat.ml

runstrat: runstrat.opt
	@rm -f runstrat
	ln -s runstrat.opt runstrat

install:
	mkdir -p $(BINDIR)
	cp runstrat.opt $(BINDIR)/runstrat
	cp makejob.opt $(BINDIR)/makejob

clean:
	rm -f *.cmo *.cma *.cmx *.cmi *.o *.annot *.opt
	rm -f runstrat makejob

### Tests ###

.PHONY: test_makejob %.test_makejob_aux

TEST_MAKEJOB=$(addsuffix .test_makejob_aux , $(shell seq 5 -1 1))

test_makejob: $(TEST_MAKEJOB)
	@echo Done $(TEST_MAKEJOB)

%.test_makejob_aux: makejob
	@echo Run $*
	+./run_wait.ml e 10 ./echo_wait.ml $*
	@echo Done $*


################
# generic rules
################

%.cmi: %.mli
	$(SHOW) 'Ocamlc   $<'
	$(HIDE)$(OCAMLC) -c $<

%.cmo: %.ml
	$(SHOW) 'Ocamlc   $<'
	$(HIDE)$(OCAMLC) -c $<

%.cmx: %.ml
	$(SHOW) 'Ocamlopt $<'
	$(HIDE)$(OCAMLOPT) -c $<

%.dep: %.ml
	$(SHOW) 'Ocamldep $<'
	$(HIDE)$(OCAMLDEP) $(DEPFLAGS) $< $<i $(TOTARGET)

%.opt:
	$(SHOW) 'Ocamlopt $<'
	$(HIDE)$(OCAMLOPT) -linkpkg -o $@ $^

%.byte:
	$(SHOW) 'Ocamlc   $<'
	$(HIDE)$(OCAMLC) -linkpkg -o $@ $^

=== debian/changelog ===
why3 (1.2.1-6) unstable; urgency=medium

  * Add build-dependency libnum-ocaml-dev (used to be pulled in by coq)
  * Bump build-dependency on ocaml, as indicated by opam file

 -- Ralf Treinen <treinen@debian.org>  Sun, 08 Mar 2020 20:36:59 +0100

why3 (1.2.1-5) unstable; urgency=medium

  * debian/rules: include coqvars.mk, and set F:CoqABI substvar, only where
    that file exists.

 -- Ralf Treinen <treinen@debian.org>  Sun, 08 Mar 2020 17:34:13 +0100

why3 (1.2.1-4) unstable; urgency=medium

  * Support new coq versions:
    - add patch coq-8.10+11:
    - invoke autoconf in debian/rules, add it to build-depends
  * Since coq does no longer build on all release architectures:
    - Mark the test why3+coq as skip-not-installable
    - Restrict build-dependencies on coq to amd64 arm64 ppc64 ppc64el sh4
    - Restrict recommendation of why3-coq to amd64 arm64 ppc64 ppc64el sh4
    - Build why3-coq only on amd64 arm64 ppc64 ppc64el sh4
  * Standards-Version 4.5.0 (no change)
  * Drop override of dh_dwz which is no longer needed.

 -- Ralf Treinen <treinen@debian.org>  Sun, 08 Mar 2020 16:35:43 +0100

why3 (1.2.1-3) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Fix FTBFS with menhir 20200123 (Closes: #951052)

  [ Ralf Treinen ]
  * drop cvc3 from Recommends and debian/tests as the cvc3 package has
    been removed from sid.

 -- Stéphane Glondu <glondu@debian.org>  Mon, 10 Feb 2020 13:57:51 +0100

why3 (1.2.1-2) unstable; urgency=medium

  * patch hardening-flags: use hardening flags when compiling the
    why3 server.

 -- Ralf Treinen <treinen@debian.org>  Sun, 03 Nov 2019 22:02:08 +0100

why3 (1.2.1-1) unstable; urgency=medium

  * New upstream version.
  * Drop patch lablgtk3-beta6 which is now applied by upstream.
  * Bumped dependency on z3 to << 4.8.7 (d/control and d/tests/control)

 -- Ralf Treinen <treinen@debian.org>  Mon, 28 Oct 2019 18:48:39 +0100

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,18 @@
 Uploaders: Ralf Treinen <treinen@debian.org>
 Build-Depends:
   debhelper-compat (= 12), dh-ocaml,
-  ocaml-nox (>= 3.11.2),
+  autoconf,
+  ocaml-nox (>= 4.05.5),
   ocaml-findlib,
-  menhir, libmenhir-ocaml-dev,
+  menhir (>= 20200123),
+  libmenhir-ocaml-dev (>= 20200123),
   libzarith-ocaml-dev,
   libsqlite3-ocaml-dev,
   libzip-ocaml-dev,
+  libnum-ocaml-dev,
   libocamlgraph-ocaml-dev,
-  coq, libcoq-ocaml-dev,
+  coq [amd64 arm64 ppc64 ppc64el sh4],
+  libcoq-ocaml-dev [amd64 arm64 ppc64 ppc64el sh4],
   liblablgtk3-ocaml-dev, liblablgtksourceview3-ocaml-dev,
   tex-common
 Build-Depends-Indep:
@@ -21,7 +25,7 @@
   texlive-latex-recommended, texlive-latex-extra,
   texlive-fonts-recommended,
   texlive-bibtex-extra
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: http://why3.lri.fr/
 Vcs-Git: https://salsa.debian.org/ocaml-team/why3.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/why3
@@ -32,7 +36,7 @@
   ${shlibs:Depends},
   ${ocaml:Depends},
   ${misc:Depends},
-Recommends: cvc3 | cvc4 | why3-coq | spass | z3 (<< 4.8.5) | alt-ergo (>= 2.0.0)
+Recommends: cvc4 | why3-coq [amd64 arm64 ppc64 ppc64el sh4]| spass | z3 (<< 4.8.7) | alt-ergo (>= 2.0.0)
 Suggests: why3-examples
 Description: Software verification platform
  Why3 is a platform for deductive program verification. It provides a
@@ -56,7 +60,7 @@
  a new external prover if wanted.
 
 Package: why3-coq
-Architecture: any
+Architecture: amd64 arm64 ppc64 ppc64el sh4
 Depends: coq-${F:CoqABI}, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
 Recommends: why3
 Description: Coq support for the why3 verification platform

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR=debian/tmp

HAVE_COQVARS ?= $(if $(wildcard /usr/share/coq/coqvars.mk),yes,no)

ifeq ($(HAVE_COQVARS),yes)
  include /usr/share/coq/coqvars.mk
endif

%:
	dh $@ --with ocaml,tex

override_dh_auto_configure: configure-stamp

configure-stamp:
	autoconf
	dh_auto_configure -- \
		--disable-emacs-compilation
	touch configure-stamp

build-arch: configure-stamp
	dh_testdir
	$(MAKE) all byte

build-indep: configure-stamp
	dh_testdir
	$(MAKE) doc

build: build-arch build-indep

override_dh_auto_install:
	# do nothing

override_dh_install-arch: build-arch
	$(MAKE) install install-lib DESTDIR=$(CURDIR)/$(BUILDDIR)
	dh_install -a -XLICENSE
ifeq ($(HAVE_COQVARS),yes)
	echo 'F:CoqABI=$(COQ_ABI)' >> debian/why3-coq.substvars
endif

override_dh_installexamples:
	dh_installexamples
	if [ -d debian/why3-examples/usr/share/doc/why3-examples/examples ]; \
	then \
	  find debian/why3-examples/usr/share/doc/why3-examples/examples \
	    -name why3shapes.gz \
	    -exec sh -c 'if [ $$(zcat {} | wc -c) -eq 0 ]; then \rm {}; fi' \;;\
	fi

override_dh_install-indep:
	# do nothing

override_dh_missing:
	dh_missing --fail-missing

override_dh_compress:
	dh_compress -Xmanual.pdf

override_dh_ocaml:
	dh_ocaml --nodefined-map=why3-coq:Why3,MenhirLib,Gzip,Zlib,Zip \

=== debian/tests/control ===
Tests: why3+alt-ergo
Depends: why3, alt-ergo (>= 2.0.0)
Restrictions: skip-not-installable

Tests: why3+cvc4
Depends: why3, cvc4
Restrictions: skip-not-installable

Tests: why3+spass
Depends:why3, spass
Restrictions: skip-not-installable

Tests: why3+z3
Depends:why3, z3 (<< 4.8.7)
Restrictions: skip-not-installable

Tests: why3+coq
Depends: why3, why3-coq, coq
Restrictions: skip-not-installable

## why3 1.3.1

=== debian/changelog ===
why3 (1.3.1-2) unstable; urgency=medium

  * Add Build-Depends-Indep: graphviz

 -- Ralf Treinen <treinen@debian.org>  Tue, 07 Apr 2020 19:11:39 +0200

why3 (1.3.1-1) unstable; urgency=medium

  * New upstream version.
    This version contains the micro-C plugin (closes: #950605)
  * Drop patches fixed by this upstream version:
    - coq-8.10+11
    - 0002-Move-menhirLib-from-EXTOBJS-to-EXTLIBS
  * Refresh patch hardening-flags
  * Upstream switched the building of the documentation to sphinx:
    - added build-dependencies python3-sphinx, python3-sphinxcontrib.bibtex
    - dropped build-dependencies rubber, hevea, lmodern
    - why3-doc-pdf.docs: update path of manual.pdf
  * configuration: explicitly set --libdir
  * debian/rules: simplify by using override_dh_auto_build-{arch,indep}
  * Test why+coq: use /tmp when $ADT_ARTIFACTS is not set
  * why3-doc-html:
    - depend on libjs-{jquery,underscore}
    - use why3-doc-html.links to symlink these libraries, replacing the
      embedded copies
    - remove calls to the mathjax library from generated html code
  
 -- Ralf Treinen <treinen@debian.org>  Mon, 06 Apr 2020 09:35:10 +0200

=== debian/control ===
--- 
+++ 
@@ -20,11 +20,12 @@
   liblablgtk3-ocaml-dev, liblablgtksourceview3-ocaml-dev,
   tex-common
 Build-Depends-Indep:
-  rubber, hevea, lmodern,
+  python3-sphinx, python3-sphinxcontrib.bibtex,
   texlive-plain-generic,
   texlive-latex-recommended, texlive-latex-extra,
   texlive-fonts-recommended,
-  texlive-bibtex-extra
+  texlive-bibtex-extra,
+  graphviz
 Standards-Version: 4.5.0
 Homepage: http://why3.lri.fr/
 Vcs-Git: https://salsa.debian.org/ocaml-team/why3.git
@@ -89,7 +90,10 @@
 
 Package: why3-doc-html
 Architecture: all
-Depends: ${misc:Depends}
+Depends: ${misc:Depends},
+  libjs-jquery,
+  libjs-underscore,
+  libjs-mathjax
 Suggests: why3
 Description: HTML Documentation of the why3 verification platform
  This package contains the tutorial and reference manual of the

=== debian/rules ===
--- 
+++ 
@@ -11,23 +11,22 @@
 %:
 	dh $@ --with ocaml,tex
 
-override_dh_auto_configure: configure-stamp
-
-configure-stamp:
+override_dh_auto_configure:
 	autoconf
 	dh_auto_configure -- \
-		--disable-emacs-compilation
-	touch configure-stamp
+		--disable-emacs-compilation \
+		--libdir=/usr/lib/ocaml
 
-build-arch: configure-stamp
-	dh_testdir
+override_dh_auto_build-arch:
 	$(MAKE) all byte
 
-build-indep: configure-stamp
-	dh_testdir
+override_dh_auto_build-indep:
 	$(MAKE) doc
-
-build: build-arch build-indep
+	cd doc/html; \
+	for f in *.html; do \
+	  sed -e "s|https://cdnjs.cloudflare.com/ajax/libs/mathjax/[0-9.]\+/latest.js|/usr/share/javascript/mathjax/MathJax.js|" $$f > $$f.out; \
+	  mv $$f.out $$f; \
+	done
 
 override_dh_auto_install:
 	# do nothing
@@ -39,6 +38,9 @@
 	echo 'F:CoqABI=$(COQ_ABI)' >> debian/why3-coq.substvars
 endif
 
+override_dh_install-indep:
+	# do nothing
+
 override_dh_installexamples:
 	dh_installexamples
 	if [ -d debian/why3-examples/usr/share/doc/why3-examples/examples ]; \
@@ -48,9 +50,6 @@
 	    -exec sh -c 'if [ $$(zcat {} | wc -c) -eq 0 ]; then \rm {}; fi' \;;\
 	fi
 
-override_dh_install-indep:
-	# do nothing
-
 override_dh_missing:
 	dh_missing --fail-missing

## why3 1.3.2

=== debian/changelog ===
why3 (1.3.2-1build1) groovy; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 15 Sep 2020 15:12:55 +0200

why3 (1.3.2-1) unstable; urgency=medium

  * New upstream release.
  * Add patch coq8.12: support coq versions 8.11.* and 8.12.*
    (thanks to Guillaume Melquiond)
  * Test why3+coq: send warning to stderr
  * Replace embedded sphinx javascript libraries by symlinks,
    and add dependency on libjs-sphinxdoc to package why3-doc-html.
  * debian/control: update architecture of the why3-coq package, and
    architecture strings in build-dependencies on coq stuff.

 -- Ralf Treinen <treinen@debian.org>  Thu, 10 Sep 2020 23:09:31 +0200

why3 (1.3.1-3) unstable; urgency=medium

  * Team upload
  * Include ocamlvars.mk to prevent FTBFS in dh_dwz
  * Bump debhelper compat level to 13
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Sun, 16 Aug 2020 01:08:26 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders: Ralf Treinen <treinen@debian.org>
 Build-Depends:
-  debhelper-compat (= 12), dh-ocaml,
+  debhelper-compat (= 13), dh-ocaml,
   autoconf,
   ocaml-nox (>= 4.05.5),
   ocaml-findlib,
@@ -15,8 +15,8 @@
   libzip-ocaml-dev,
   libnum-ocaml-dev,
   libocamlgraph-ocaml-dev,
-  coq [amd64 arm64 ppc64 ppc64el sh4],
-  libcoq-ocaml-dev [amd64 arm64 ppc64 ppc64el sh4],
+  coq [!s390x],
+  libcoq-ocaml-dev [!s390x],
   liblablgtk3-ocaml-dev, liblablgtksourceview3-ocaml-dev,
   tex-common
 Build-Depends-Indep:
@@ -27,6 +27,7 @@
   texlive-bibtex-extra,
   graphviz
 Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Homepage: http://why3.lri.fr/
 Vcs-Git: https://salsa.debian.org/ocaml-team/why3.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/why3
@@ -37,7 +38,7 @@
   ${shlibs:Depends},
   ${ocaml:Depends},
   ${misc:Depends},
-Recommends: cvc4 | why3-coq [amd64 arm64 ppc64 ppc64el sh4]| spass | z3 (<< 4.8.7) | alt-ergo (>= 2.0.0)
+Recommends: cvc4 | why3-coq [!s390x]| spass | z3 (<< 4.8.7) | alt-ergo (>= 2.0.0)
 Suggests: why3-examples
 Description: Software verification platform
  Why3 is a platform for deductive program verification. It provides a
@@ -61,7 +62,7 @@
  a new external prover if wanted.
 
 Package: why3-coq
-Architecture: amd64 arm64 ppc64 ppc64el sh4
+Architecture: amd64 arm64 armel armhf i386 mipsel64 mipsel ppc64 ppc64el hurd-i386 powerpc ppc64el riscv64 sh4 sparc64 x32
 Depends: coq-${F:CoqABI}, ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
 Recommends: why3
 Description: Coq support for the why3 verification platform
@@ -93,7 +94,8 @@
 Depends: ${misc:Depends},
   libjs-jquery,
   libjs-underscore,
-  libjs-mathjax
+  libjs-mathjax,
+  libjs-sphinxdoc
 Suggests: why3
 Description: HTML Documentation of the why3 verification platform
  This package contains the tutorial and reference manual of the

## why3 1.3.3

=== examples/c_cursor/Makefile ===
BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
endif

clean:
	rm -rf build

dir:
	mkdir -p build

why3:
	make -C ../..

extract: why3 dir
	$(WHY3) extract -D cursor.drv -D c -L . -o build/ptrcursor.c ccursor.PtrCursor

cfiles: extract
	gcc -Wall -g -pedantic -Wno-unused-function -std=c11 build/ptrcursor.c -Ibuild -o build/tests

tests: cfiles
	./build/tests

=== examples/euler001/Makefile ===
--- 
+++ 
@@ -37,10 +37,10 @@
 	$(WHY3) session html .
 
 $(MAIN).byte: $(CMO)  $(MAIN).cmo
-	ocamlc $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ $^
+	ocamlc $(INCLUDE) $(BIGINTLIB).cma -o $@ $^
 
 $(MAIN).opt: $(CMX)  $(MAIN).cmx
-	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^
+	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa -o $@ $^
 
 $(MAIN).cmx: $(CMX)

=== examples/gcd/Makefile ===
--- 
+++ 
@@ -39,7 +39,7 @@
 	$(WHY3) session html .
 
 $(MAIN).opt: $(CMX)  $(MAIN).cmx
-	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^
+	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa -o $@ $^
 
 $(MAIN).cmx: $(CMX)
 
@@ -58,11 +58,10 @@
 
 JSMAIN=jsmain
 
-JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml.syntax \
-          -syntax camlp4o
+JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml.ppx -package js_of_ocaml-lwt
 
 $(JSMAIN).js: $(JSMAIN).byte
-	js_of_ocaml -pretty -noinline $(JSMAIN).byte
+	js_of_ocaml --pretty --noinline $(JSMAIN).byte
 
 
 $(JSMAIN).byte: $(ML) jsmain.ml

=== examples/multiprecision/Makefile ===
BENCH ?= no
OVERLAY ?= no
LOCAL ?= $(BENCH)

ifeq ($(LOCAL),yes)
  WHY3=../../bin/why3.opt
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
endif

ifdef GMP_DIR
  CFLAGS = $(shell sed -n -e 's/^CFLAGS = \(.*\)/\1/p' $(GMP_DIR)/Makefile)
else
  CFLAGS = -march=native -O2 -fomit-frame-pointer
endif

ifdef GMP_LIB
  GMPFLAGS = -I$(GMP_LIB)/include -L$(GMP_LIB)/lib
endif

CFLAGS += -Wall -Wno-unused -g -std=c11 -Wno-pedantic

.PHONY: all clean extract plots benchs why3benchs gmpbenchs minigmpbenchs

all: extract

clean:
	rm -rf build bench

why3:
	make -C ../..

MLWFILES = \
  mpz_div2exp mpz_mul2exp mpz_div mpz_mul mpz_sub mpz_add mpz_getset mpz_abs mpz_cmp mpz_cmpabs mpz \
  set_str get_str base_info powm sqrtrem sqrt toom logical div mul sub add compare util

build/extracted: $(addsuffix .mlw, $(MLWFILES))
	mkdir -p build
	rm -f $@
	$(WHY3) extract -D wmpn.drv -D c -L . --recursive --modular --interface -o build/ \
	  --debug c_no_error_msgs wmpn.mlw
	touch $@

build/sqrtinit.h: sqrtinit.ml
	mkdir -p build
	ocaml sqrtinit.ml > build/sqrtinit.h

build/binverttab.h: binverttab.ml
	mkdir -p build
	ocaml binverttab.ml > build/binverttab.h

EXTRACTED = build/extracted build/sqrtinit.h build/binverttab.h

extract: $(EXTRACTED)

CFILES = \
  zutil.c z.c zcmp.c zcmpabs.c zabs.c zadd.c zsub.c zmul.c zdiv.c zmul2exp.c zdiv2exp.c \
  set.c get_str.c set_str.c baseinfo.c powm.c fxp.c sqrt.c sqrt1.c toom.c div.c \
  logical.c logicalold.c logicalutil.c mul_basecase.c sub.c sub_1.c add.c add_1.c \
  compare.c util.c utilold.c int32.c

ifneq ($(OVERLAY),gmp)
CFILES += mul.c addold.c subold.c
endif

gmp_INCLUDES = mul.h add.h sub.h
mini_INCLUDES = uint64gmp.h
no_INCLUDES =
INCLUDES = $($(OVERLAY)_INCLUDES)

build/libwmp.a: $(EXTRACTED)
	cd build; gcc $(CFLAGS) $(INCLUDES:%=-include ../overlays/%) -c $(CFILES)
	ar rcs $@ $(addprefix build/,$(CFILES:.c=.o))

build/tests: tests.c build/libwmp.a
	gcc $(CFLAGS) tests.c -Irandom -Lbuild -lm -lwmp -lgmp -o $@

build/minitests: tests.c build/libwmp.a
	gcc $(CFLAGS) -DCOMPARE_MINI tests.c -Irandom -Imini-gmp -Lbuild -lm -lwmp -o $@

UPPER = $(shell echo $* | tr [:lower:] [:upper:])

build/why3%bench: tests.c build/libwmp.a
	gcc $(CFLAGS) -DTEST_WHY3 -DTEST_$(UPPER) tests.c -Iinclude -Irandom -Lbuild -lm -lwmp -lgmp -o $@

build/gmp%bench: tests.c build/libwmp.a
	gcc $(CFLAGS) $(GMPFLAGS) -DTEST_GMP -DTEST_$(UPPER) tests.c -Iinclude -Irandom -lm -lgmp -o $@

build/minigmp%bench: tests.c build/libwmp.a
	gcc $(CFLAGS) -DTEST_MINIGMP -DTEST_$(UPPER) tests.c -Iinclude -Imini-gmp -Irandom -lm -o $@

BENCHS = toomb sqrtrem millerrabin toomu add mul div powm toomm


WHY3BENCHFILES = $(addprefix bench/why3, $(BENCHS))
GMPBENCHFILES = $(addprefix bench/gmp, $(BENCHS))
MINIGMPBENCHFILES = $(addprefix bench/minigmp, $(BENCHS))
BENCHFILES = $(WHY3BENCHFILES) $(GMPBENCHFILES) $(MINIGMPBENCHFILES)

$(BENCHFILES): bench/%: build/%bench
	mkdir -p bench
	$< > $@

why3benchs: $(WHY3BENCHFILES)
gmpbenchs: $(GMPBENCHFILES)
minigmpbenchs: $(MINIGMPBENCHFILES)
benchs: why3benchs gmpbenchs minigmpbenchs

plots: $(BENCHFILES)
	make all -C plots

=== examples/prover/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif


BD=prover
OCAMLC=ocamlopt.opt
INCLUDES=$(INCLUDEALL) -I ../../plugins/tptp
LIBS=unix.cmxa nums.cmxa $(BIGINTLIB).cmxa dynlink.cmxa str.cmxa menhirLib.cmx zip.cmxa why3.cmxa why3extract.cmxa tptp_ast.cmx tptp_typing.cmx tptp_parser.cmx tptp_lexer.cmx
WHY3FLAGS=-L . --debug ignore_unused_vars
MLFLAGS=
MLIFLAGS=
MLEXECFLAGS=

.PHONY: clean depend extract replay

$(BD): $(BD).cmx run.cmx
	echo "WHY3SHARE="$(WHY3SHARE)
	$(OCAMLC) $(INCLUDES) $(LIBS) $(MLFLAGS) $(MLEXECFLAGS) \
		-o $(BD) $^

extract: $(ML)

$(BD).ml:
	why3 $(WHY3FLAGS) extract -D ocaml64 -o $(BD).ml ProverTest.mlw

%.cmx: %.ml
	$(OCAMLC) $(INCLUDES) $(MLFLAGS) -c $<

.depend: Makefile $(ML)
	ocamldep.opt -I $(BD) $(ML) > .depend

ifneq "$(MAKECMDGOALS:clean%=clean)" "clean"
ifneq "$(MAKECMDGOALS:extract%=extract)" "extract"
ifneq "$(MAKECMDGOALS:extract%=replay)" "replay"
include .depend
endif
endif
endif

replay:
	@printf "===================================\n"
	@printf "Starting time (UTC): "
	@date --utc +%H:%M
	@printf "===================================\n"
	@for i in *.mlw; do \
		printf "Replaying $$i..." ; \
		why3 $(WHY3FLAGS) replay -q `basename $$i .mlw` ; \
	 done
	@printf "===================================\n"
	@printf "Ending time (UTC): "
	@date --utc +%H:%M
	@printf "===================================\n"

depend: .depend

clean:
	rm -f $(BD)/*.o $(BD)/*.cmi $(BD)/*.cmx
	rm -f $(BD)*.ml
	rm -f *~ *.o *.cmi *.cmx build/prover

=== examples/sudoku/Makefile ===
--- 
+++ 
@@ -39,10 +39,10 @@
 	$(WHY3) session html .
 
 $(MAIN).byte: $(CMO) $(MAIN).cmo
-	ocamlc -g $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ $^
+	ocamlc -g $(INCLUDE) $(BIGINTLIB).cma -o $@ $^
 
 $(MAIN).opt: $(CMX) $(MAIN).cmx
-	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^
+	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa -o $@ $^
 
 $(MAIN).cmx: $(CMX)
 
@@ -54,14 +54,13 @@
 
 JSMAIN=jsmain
 
-JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml.syntax \
-          -syntax camlp4o
+JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml.ppx -package js_of_ocaml-lwt
 
 $(JSMAIN).js: $(JSMAIN).byte
 	js_of_ocaml +nat.js $(JSMAIN).byte
 
 $(JSMAIN).byte: $(CMO) $(JSMAIN).cmo
-	$(JSOCAMLC) $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ -linkpkg $^
+	$(JSOCAMLC) $(INCLUDE) $(BIGINTLIB).cma -o $@ -linkpkg $^
 
 %.cmo: %.ml
 	$(JSOCAMLC) $(INCLUDE) -annot -c $<

=== examples/use_api/Makefile ===
OCAMLC=ocamlc.opt
OCAMLOPT=ocamlopt.opt
COMP=$(OCAMLOPT)
COMP=$(OCAMLC)

ROOT=../..

OPAM_LIB=$(shell opam config var lib)

PPXFLAGS=-ppx "$(OPAM_LIB)/ppx_deriving/ppx_deriving package:ppx_optcomp"

FLAGS=$(PPXFLAGS) -g

EXE=\
	mlw_tree \
	why3_prove \
	why3_ptree

INCLUDES=-I $(ROOT)/lib/why3 -I $(ROOT)/lib/why3 -I $(OPAM_LIB)/zip -I $(OPAM_LIB)/menhirLib
LIBS=\
	 menhirLib.cma \
	 str.cma \
	 unix.cma \
	 nums.cma \
	 dynlink.cma \
	 zip.cma \
	 $(ROOT)/lib/why3/why3.cma

all: clean $(EXE)

mlw_tree: mlw_tree.ml
	$(COMP) $(FLAGS) -o $@ $(INCLUDES) $(LIBS) $(ROOT)/examples/use_api/mlw_tree.ml

why3_prove: why3_prove.ml
	$(COMP) $(FLAGS) -o $@ $(INCLUDES) $(LIBS) $(ROOT)/examples/use_api/why3_prove.ml

why3_ptree: why3ml_pp.ml why3_ptree.ml
	$(COMP) $(FLAGS) -o $@ $(INCLUDES) $(LIBS) $(ROOT)/examples/use_api/why3ml_pp.ml $(ROOT)/examples/use_api/why3_ptree.ml

clean:
	rm -fv *.cm* *.o $(EXE)

=== examples/vstte12_combinators/Makefile ===
--- 
+++ 
@@ -39,7 +39,7 @@
 	$(WHY3) session html .
 
 $(MAIN).opt: $(CMX)  $(MAIN).cmx
-	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa why3extract.cmxa -o $@ $^
+	$(OCAMLOPT) $(INCLUDE) $(BIGINTLIB).cmxa -o $@ $^
 
 $(MAIN).cmx: $(CMX)
 
@@ -58,16 +58,15 @@
 
 JSMAIN=jsmain
 
-JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml.syntax \
-          -syntax camlp4o
+JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml.ppx -package js_of_ocaml-lwt
 
 $(JSMAIN).js: $(JSMAIN).byte
-	js_of_ocaml -pretty -noinline +nat.js $(JSMAIN).byte
+	js_of_ocaml --pretty --noinline +nat.js $(JSMAIN).byte
 
 
 $(JSMAIN).byte: $(CMO) jsmain.ml
 #	$(JSOCAMLC) $(INCLUDE) -o $@ -linkpkg $^
-	$(JSOCAMLC) $(INCLUDE) $(BIGINTLIB).cma why3extract.cma -o $@ -linkpkg $^
+	$(JSOCAMLC) $(INCLUDE) $(BIGINTLIB).cma -o $@ -linkpkg $^
 
 
 %.cmo: %.ml

=== debian/changelog ===
why3 (1.3.3-3build1) jammy; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 07 Nov 2021 02:00:39 +0100

why3 (1.3.3-3) unstable; urgency=medium

  * Add new tex-gyre dependency, useful to fix a build failure on
    pdflatex doc generation, Thanks <bunk> for the hint and patch!

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 26 Oct 2021 15:17:59 +0200

why3 (1.3.3-2) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Cherry-pick two upstream fixes for new sphinx-bibtex version:
    - d/p/99377bc169d86f86b167150624d248f01d9025f9.patch:
    - d/p/50f39bb6164bd40ed580a12452f83853f885c344.patch:
      (Closes: #995603)
  [ Ralf Treinen ]
  * debian/watch: format version 4

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 26 Oct 2021 09:47:54 +0200

why3 (1.3.3-1) unstable; urgency=medium

  * New upstream release:
    - drop patch why8.12, issue is solved by upstream
  * Alternative dependency of why3, and test dependency on cvc4: add a
    version constraint << 1.8 since cvc4 is supported only up to upstream
    version 1.7 (closes: #970510)

 -- Ralf Treinen <treinen@debian.org>  Wed, 23 Sep 2020 21:23:15 +0200

=== debian/control ===
--- 
+++ 
@@ -25,6 +25,7 @@
   texlive-latex-recommended, texlive-latex-extra,
   texlive-fonts-recommended,
   texlive-bibtex-extra,
+  tex-gyre,
   graphviz
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
@@ -38,7 +39,7 @@
   ${shlibs:Depends},
   ${ocaml:Depends},
   ${misc:Depends},
-Recommends: cvc4 | why3-coq [!s390x]| spass | z3 (<< 4.8.7) | alt-ergo (>= 2.0.0)
+Recommends: cvc4 (<< 1.8) | why3-coq [!s390x]| spass | z3 (<< 4.8.7) | alt-ergo (>= 2.0.0)
 Suggests: why3-examples
 Description: Software verification platform
  Why3 is a platform for deductive program verification. It provides a

=== debian/watch ===
version=4
opts=uversionmangle=s/-/~/ \
https://gforge.inria.fr/frs/?group_id=2990 .*/why3-(.*)\.tar\.gz
